#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif

varying vec2 vTexCoord;
uniform sampler2D texture;   // 原图
uniform sampler2D shadowTexture; // 高光阴影素材图
uniform sampler2D blendTexture; // 高光阴影素材图

float blendSoftLight(float base, float blend) {
    return (blend<0.5)?(2.0*base*blend+base*base*(1.0-2.0*blend)):(sqrt(base)*(2.0*blend-1.0)+2.0*base*(1.0-blend));
}

vec3 blendSoftLight(vec3 base, vec3 blend) {
    return vec3(blendSoftLight(base.r,blend.r),blendSoftLight(base.g,blend.g),blendSoftLight(base.b,blend.b));
}

vec3 blendFunc(vec3 base, vec3 blend, float opacity) {
    return (blendSoftLight(base, blend) * opacity + base * (1.0 - opacity));
}

void main()
{
    vec4 clothes = texture2D(texture, vTexCoord);
    vec4 shadow = texture2D(shadowTexture, vTexCoord);

    // 正常混合模式
    vec3 temp = mix(clothes.rgb, shadow.rgb, shadow.a);
    gl_FragColor = vec4(temp.rgb, clothes.a);
    // 柔光混合模式
    //gl_FragColor = vec4(blendFunc(clothes.rgb, shadow.rgb, shadow.a), clothes.a);
}
